GCOVR(1)

NAME
gcovr - generate simple coverage reports

DESCRIPTION
usage: gcovr [options] [search_paths...]

A utility to run gcov and summarize the coverage in simple reports.

OPTIONS

-h, --help
    Show this help message, then exit.

--version
    Print the version number, then exit.

-v, --verbose
    Print progress messages. Please include this output in bug reports.

-r ROOT, --root ROOT
    The root directory of your source files. Defaults to '.', the current directory. File names are reported relative to this root. The --root is the default --filter.

search_paths
    Search these directories for coverage files. Defaults to --root and --object-directory.

--fail-under-line MIN
    Exit with a status of 2 if the total line coverage is less than MIN. Can be ORed with exit status of '-- fail-under-branch' option.

--fail-under-branch MIN
    Exit with a status of 4 if the total branch coverage is less than MIN. Can be ORed with exit status of '-- fail-under-line' option.

--source-encoding SOURCE_ENCODING
    Select the source file encoding. Defaults to the system default encoding (ANSI_X3.4-1968).

--html-medium-threshold MEDIUM
    If the coverage is below MEDIUM, the value is marked as low coverage in the HTML report. MEDIUM has to be lower than or equal to value of --html-high-threshold. If MEDIUM is equal to value of --html-high-threshold the report has only high and low coverage. Default is 75.0.

--html-high-threshold HIGH
    If the coverage is below HIGH, the value is marked as medium coverage in the HTML report. HIGH has to be greater than or equal to value of --html-mediumthreshold. If HIGH is equal to value of --html-mediumthreshold the report has only high and low coverage. Default is 90.0.

  Output Options:

    Gcovr prints a text report by default, but can switch to XML or HTML.

-o OUTPUT, --output OUTPUT
    Print output to this filename. Defaults to stdout. Required for --html-details.

-b, --branches
    Report the branch coverage instead of the line coverage. For text report only.

-u, --sort-uncovered
    Sort entries by increasing number of uncovered lines. For text and HTML report.

-p, --sort-percentage
    Sort entries by increasing percentage of uncovered lines. For text and HTML report.

-x, --xml
    Generate a Cobertura XML report.

--xml-pretty
    Pretty-print the XML report. Implies --xml. Default: False.

--html
    Generate a HTML report.

--html-details
    Add annotated source code reports to the HTML report. Requires --output as a basename for the reports. Implies --html.

--html-title TITLE
    Use TITLE as title for the HTML report. Default is Head.

--html-absolute-paths
    Use absolute paths to link the --html-details reports. Defaults to relative links.

--html-encoding HTML_ENCODING
    Override the declared HTML report encoding. Defaults to UTF-8. See also --source-encoding.

-s, --print-summary
    Print a small report to stdout with line & branch percentage coverage. This is in addition to other reports. Default: False.

  Filter Options:

    Filters decide which files are included in the report. Any filter must match, and no exclude filter must match. A filter is a regular expression that matches a path. Filter paths use forward slashes, even on Windows.

-f FILTER, --filter FILTER
    Keep only source files that match this filter. Can be specified multiple times. If no filters are provided, defaults to --root.

-e EXCLUDE, --exclude EXCLUDE
    Exclude source files that match this filter. Can be specified multiple times.

--gcov-filter GCOV_FILTER
    Keep only gcov data files that match this filter. Can be specified multiple times.

--gcov-exclude GCOV_EXCLUDE
    Exclude gcov data files that match this filter. Can be specified multiple times.

--exclude-directories EXCLUDE_DIRS
    Exclude directories that match this regex while searching raw coverage files. Can be specified multiple times.

  GCOV Options:

    The 'gcov' tool turns raw coverage files (.gcda and .gcno) into .gcov files that are then processed by gcovr. The gcno files are generated by the compiler. The gcda files are generated when the instrumented program is executed.

--gcov-executable GCOV_CMD
    Use a particular gcov executable. Must match the compiler you are using, e.g. 'llvm-cov gcov' for Clang. Can include additional arguments. Defaults to the GCOV environment variable, or 'gcov': 'gcov'.

--exclude-unreachable-branches
    Exclude branch coverage with LCOV/GCOV exclude markers. Additionally, exclude branch coverage from lines without useful source code (often, compilergenerated "dead" code). Default: False.

-g, --use-gcov-files
    Use existing gcov files for analysis. Default: False.

--gcov-ignore-parse-errors
    Skip lines with parse errors in GCOV files instead of exiting with an error. A report will be shown on stderr. Default: False.

--object-directory OBJDIR
    Override normal working directory detection. Gcovr needs to identify the path between gcda files and the directory where the compiler was originally run. Normally, gcovr can guess correctly. This option specifies either the path from gcc to the gcda file (i.e. gcc's '-o' option), or the path from the gcda file to gcc's working directory.

-k, --keep
    Keep gcov files after processing. This applies both to files that were generated by gcovr, or were supplied via the --use-gcov-files option. Default: False.

-d, --delete
    Delete gcda files after processing. Default: False.

-j [GCOV_PARALLEL]
    Set the number of threads to use in parallel.

See <http://gcovr.com/> for the full manual.